#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "toolkit.h"
#include "tine.h"
#include "cdi.h"
#include "tinecdi.h"
#include "cdiSedpcLib.h"

extern int waitSedPCfinished(void);
int cdiInitSedPC(void)
{
  int cc = 0;

  if ((cc=cdiRegisterBusFilter("SEDPC",filterSedacBus)) != 0 ) goto err;
  if ((cc=cdiRegisterBusInitialization("SEDPC",initSedacForCDI)) != 0 ) goto err;
  if ((cc=cdiRegisterBusHandler("SEDPC",execSedacBus)) != 0 ) goto err;
  if ((cc=cdiRegisterBusCleanup("SEDPC",exitSedac)) != 0 ) goto err;
  if ((cc=cdiRegisterBusScanner("SEDPC",sedacScanFcn)) != 0 ) goto err;
  if ((cc=cdiRegisterBusBlockFunction("SEDPC",sedacBlockTrans)) != 0 ) goto err;

err:
  if (cc)
  {
    cdilog("%s : failure in bus registration SEDPC",erlst[cc]);
  }
  return cc;
}

BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      cdiInitSedPC();
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      waitSedPCfinished();
      break;
  }
  return (TRUE);
}
