#ifndef CDISEDAC_H_
#define CDISEDAC_H_

#include <winioctl.h>
#include "gpioctl.h"

#define N_SEDAC_LINES	8	/* maximum number of sedac lines */
#define u16 unsigned short
#define N_SED_BUFFERS	4	/* maximum number of buffers per sedac line */

#define SEDAC_READ		0x8000  /* mode	*/
#define	SEDAC_WRITE		0x4000
#define	CRATE_ADR		0x1f00
#define	SUB_ADR			0xff

enum execSedacParamIndex
{
  sedacSubOffset,       /* sedac subaddress offset for read */
  sedacSubOffsetSecond, /* second sedac subaddress offset for write *//*cdiReadWrite or cdiWriteRead */
  sedacSubOffsetThird,  /* sedac subaddress offset for second write cdiWriteReadWrite */
};

typedef struct {
  int bufFlag;
  PSEDAC_ARY da;	/* dynamic allocation */
  int dataSize;
} SEDAC_BUF_STRUCT;

typedef struct {
  int sedac_fd;		/* sedac File descripter */
  int cdiLine;
  HANDLE sedacHandle;

  SEDAC_BUF_STRUCT locBuffer[N_SED_BUFFERS];

  u16 sedacSimulationBuffer;
  u16 sedacSimulationCount;
} SEDAC_STRUCT;

__declspec(dllexport) int filterSedacBus(int *parameter, int accessFlag);
__declspec(dllexport) int initSedacForCDI(int busLine, int cdiLine, int numberDevices, char *parameterList);
__declspec(dllexport) void execSedacBus(CdiRequestInfoBlk *pReq);
__declspec(dllexport) int initSedac(int ln);
__declspec(dllexport) int exitSedac(int ln);
__declspec(dllexport) int doSedacRequest(CdiRequestInfoBlk *pReq, int step);
__declspec(dllexport) int sedacScanFcn(char *target,char *result,int resultBufferSize);
int execSedac(u16 ln, u16 *crate, u16 *subadd, int *RWF, u16 *data, int nwords, int flag, CdiRequestInfoBlk *pReq);

/* hmmmmm .... do we need this ? */
#define READ 1 /* for sedac input parameter */
#define WRITE -1

/* group read-write */
extern int sedac(u16 ln, u16 crate, u16 subadd, int RWF, u16 *data, int nwords, CdiRequestInfoBlk *pReq);
extern int nsedac(u16 ln, u16 *crate, u16 *subadd, int *RWF, u16 *data, int nwords);

/* single read-write */
extern int wsedac(u16 ln, u16 crate, u16 subadd, u16 data);
extern int rsedac(u16 ln, u16 crate, u16 subadd, u16 *data);

/* find sub or crate address */
extern int F_addr(int *naddr, int rwflag, u16 ln, u16 crate);
extern int F_crates(int *ncrates, int rwflag, u16 ln);

#endif /* CDISEDAC_H_ */


