/*
 * wkseqm.c    REVISION HISTORY:
 * Generated by SRVWIZARD on Tue Apr 25 22:23:12 2006
*/

#include "prolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "errors.h"
#include "rpctypes.h"
#include "swaplib.h"
#include "almsrv.h"
#include "toolkit.h"
#include "wkseqm.h"
#include "cdi.h"
#include "hdwio.h"

float g_tempBuffer[PRP_TEMP_SIZE];

void wkseqm_bkg(void)
{
  /* TODO: put your IO or other background activity here         */

  /* Clear alarms at start of IO task (see if they come back)    */
  ClearAlarm(WKSEQM_TAG,-1);

  /* make use of SetAlarm() as needed :

  SetAlarm(WKSEQM_TAG,devNr,almCode,almFlag);

  */
}

/* Alternative to 'exports.csv': You can call 'RegisterWkseqmProperties()'   */
/*   -> This might be preferable in cases where the server does not have a   */
/*   -> file system.  You should also call RegisterServerName() in lieu of   */
/*   -> the 'fecid.csv' file.                                                */

int RegisterWkseqmProperties(void)
{
  int cc = 0;
  DTYPE dout,din;

  dout.dArrayLength = PRP_TEMP_SIZE;
  dout.dFormat = CF_FLOAT;
  din.dArrayLength = 0;
  din.dFormat = CF_NULL;
  if ((cc=RegisterPropertyInformation(WKSEQM_TAG,"Temp",&dout,&din,CA_READ,AT_CHANNEL,0,"[0:100 'C]Temperature of the Sine generato",PRP_TEMP,"")) < 0) goto err;

err:
  if (cc < 0)
  {
    printf("Can't register property : %s\n>",erlst[-cc]);
  }
  return cc;
}


void wkseqm_ini(void)
{
  char devnam[16];
  int i;

  /* initialize CDI so that it gets loaded here */
  cdiInitialize();

  /* now start a link, so that poor-old single-thread VB doesn't have to block on readbacks ...*/
  startHdwIoMonitor();
  
  /* If you plan to use Property registration via API call rather than          */
  /* the exports.csv startup file, uncomment the following line:                */

  /* RegisterWkseqmProperties(); */

  /* TODO: register any device names here */
  /*       below is only an example ...   */
  for (i=0; i<NUM_WKSEQM_DEVICES; i++)
  {
    sprintf(devnam,"device_%d",i);
    RegisterDeviceName(WKSEQM_TAG,devnam,i);
  }

}

void wkseqm_exi(void)
{
  /* TODO: put your shutdown routines here */
}

int wkseqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int devnr,prpid,cc;

  /* get device number from device name                                                     */
  devnr = GetDeviceNumberEx(WKSEQM_TAG,devName,devProperty);
  /* you may want to make the following check:                                              */
  if (devnr < 0) return illegal_equipment_number;

  /* TODO: If READ properties take input data, include code to examine the contents of din. */
  /*       If different actions need to be taken at the start or end of a link, examine the */
  /*       'access' parameter against CA_FIRST or CA_LAST.                                  */
  /*       If allow format overloading (you return different data according to the request  */
  /*       format), then replace calls to putDataFromShort() etc with the desired code.     */

  prpid = GetPropertyId(WKSEQM_TAG,devProperty);

  switch (prpid)
  {
    case PRP_TEMP:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > PRP_TEMP_SIZE) return dimension_error;
          if ((cc=putValuesFromFloatEx(dout,g_tempBuffer,PRP_TEMP_SIZE,devnr)) != 0) return cc;
        }
        return 0;
    default:
        return illegal_property;
  }
}
