Attribute VB_Name = "WkseqmModule"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' WkseqmModule.bas    REVISION HISTORY:
' Generated by SRVWIZARD on Tue Apr 25 22:23:14 2006
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Global variables and constants
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Const WkseqmLocalName$ = "WKSEQM"
Private Const WkseqmNumDevices% = 100
Global Const PRP_TEMPERATURE_SIZE = 100
Global Const PRP_TEMPERATURE_UPRLIMIT = 100
Global Const PRP_TEMPERATURE_LWRLIMIT = 0
Global Const PRP_AMPLITUDE_SIZE = 100
Global Const PRP_AMPLITUDE_INSIZE = 1
Global Const PRP_AMPLITUDE_UPRLIMIT = 500
Global Const PRP_AMPLITUDE_LWRLIMIT = 0
Global Const PRP_SINE_SIZE = 1024
Global Const PRP_SINE_UPRLIMIT = 500
Global Const PRP_SINE_LWRLIMIT = -500

Global prpTemperatureBuffer(PRP_TEMPERATURE_SIZE - 1) As Single
Global prpAmplitudeBuffer(PRP_AMPLITUDE_SIZE - 1) As Single
Global prpAmplitudeIn As Single
Global prpSineBuffer(PRP_SINE_SIZE - 1) As Single
Global rbSineBuffer(PRP_SINE_SIZE - 1) As Single


Function startHdwIoMonitor() As Integer
  Dim dout As TDataType
  Dim din As TDataType
  
  din.dArrayLength = 0
  din.dFormat = CF_NULL
  din.ddata = 0
  
  ' monitor devices #3, #4, #5
  ' gCdiOutput must be a global declaration
  'dout.ddata = CADDR(gCdiOutput(0))
  
  dout.dArrayLength = 100
  dout.dFormat = CF_SHORT
  dout.ddata = CADDR(gTempRb(0))
  
  ' The callback function must be in its own .bas module (and don't try to set a break point inside it!)
  
  ' read the temperatures from the CDI hardware
  ' this will do 100 reads over the device range given
  tempId = cdiAttachLink("#1-#50", "RECV", dout, din, CA_READ, 1000, AddressOf tempCb, CM_POLL, 1)
  If tempId < 0 Then
    startHdwIoMonitor = -tempId
    Debug.Print "error in starting monitor : " + str(-tempId)
    Exit Function
  End If
  DoEvents
  
  dout.dArrayLength = 100
  dout.dFormat = CF_SHORT
  dout.ddata = CADDR(gAmplRb(0))
  
  ' read the amplitudes from the CDI hardware
  ' this will do 100 reads over the device range given
  amplId = cdiAttachLink("#101-#150", "RECV", dout, din, CA_READ, 1000, AddressOf amplCb, CM_POLL, 1)
  If amplId < 0 Then
    startHdwIoMonitor = -amplId
    Debug.Print "error in starting monitor : " + str(-amplId)
    Exit Function
  End If
  DoEvents
  
  dout.dArrayLength = 1024
  dout.dFormat = CF_SHORT
  dout.ddata = CADDR(gSineRb(0))
  
  ' read the sine curve from the CDI hardware (one of the, anyway)
  ' this will do 1024 reads at address #201
  sineId(0) = cdiAttachLink("#201", "RECV", dout, din, CA_READ, 1000, AddressOf sineCb, CM_POLL, 1)
  If sineId(0) < 0 Then
    startHdwIoMonitor = -sineId(0)
    Debug.Print "error in starting monitor : " + str(-sineId(0))
    Exit Function
  End If
  DoEvents
  
  Debug.Print "start monitor"
End Function
Sub stopHwdIoMonitor()
cdiCloseLink tempId
cdiCloseLink amplId
cdiCloseLink sineId(0)
End Sub


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' WkseqmSimulateData is a useful routine for test servers
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function WkseqmSimulateData(Offset As Double, range As Double) As Double
WkseqmSimulateData = Offset + range * Rnd
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' include WkseqmBackgroundFunction in a Timer to perform background IO, etc.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function WkseqmBackgroundFunction(srvControl As Srv) As Integer
Dim i As Integer
' TODO: put your IO or other background activity here

' If you insist on putting CDI readback here, then comment out the
'    startHdwMonitor
' in WkseqmInitFunction, and uncomment the following call to getValues
'
' getValues "#3-#5", gCdiOutput
'

' Clear alarms at start of IO task (see if they come back)
  srvControl.EqpClearAlarm -1

' TODO: replace WkseqmSimulateData() with your own data acquisition
'       and manipulation routines
'  For i = 0 To PRP_TEMPERATURE_SIZE - 1
'     prpTemperatureBuffer(i) = 20 + 5 * Rnd
'  Next
'  For i = 0 To PRP_SINE_SIZE - 1
'     prpSineBuffer(i) = Sin((i * 6.2832) / 1024) + 0.125 * Rnd
'  Next
' make use of SetAlarm() as needed :

' srvControl.EqpSetAlarm devNr, almCode, CADDR(almData(0)), 0

' set error codes as needed:
  WkseqmBackgroundFunction = 0
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' include WkseqmInitFunction in Form_load (for instance) to initialize the server
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function WkseqmInitFunction(srvControl As Srv, expName As String) As Integer
Dim rc As Integer, ID As Integer

'CDI initialization

'as a test, put some value into the CDI simulation buffer (this will be tied to the amplitude)
setValue "#1", 55

'now start a link, so that poor-old single-thread VB doesn't have to block on readbacks ...
startHdwIoMonitor

'Exit Function

' FECNAME: either read from file 'fecid.csv' or user API :
'rc = RegisterFecName(fecname$, desc$, loc$, hdw$, resp$, portoffset)

' DEVICE SERVER: device server parameters
srvControl.EqpNumberModules = WkseqmNumDevices%
srvControl.EqpName = WkseqmLocalName$
srvControl.ExportName = expName
'now enable the server
srvControl.Enabled = True
rc = srvControl.EqpStatus
If rc Then GoTo ExitWkseqmInitFunction
'Property Registration:
ID = srvControl.EqpRegisterPropertyEx("Temperature", 0, CF_NULL, "", PRP_TEMPERATURE_SIZE, CF_FLOAT, "", CA_READ, "[0:100 'C][CHANNEL]Temperature of the Sine generato")
If ID < 0 Then GoTo ExitWkseqmInitFunction
ID = srvControl.EqpRegisterPropertyEx("Amplitude", PRP_AMPLITUDE_INSIZE, CF_FLOAT, "", PRP_AMPLITUDE_SIZE, CF_FLOAT, "", CA_READ + CA_WRITE, "[0:500 V][CHANNEL]Sine Curve Amplitude")
If ID < 0 Then GoTo ExitWkseqmInitFunction
ID = srvControl.EqpRegisterPropertyEx("Sine", 0, CF_NULL, "", PRP_SINE_SIZE, CF_FLOAT, "", CA_READ, "[-500:500 V]Sine Curve")
If ID < 0 Then GoTo ExitWkseqmInitFunction
'Device Name Registration:
' TODO: fill in the devices name which make sense for your server
For i = 0 To WkseqmNumDevices% - 1
  rc = srvControl.EqpRegisterModule("DEVICE" + Trim$(str$(i)), i)
  If rc Then GoTo ExitWkseqmInitFunction
Next


For i = 0 To PRP_AMPLITUDE_SIZE - 1
  prpAmplitudeBuffer(i) = 200
Next


' Everything should be okay, check for deeper problems:
WkseqmInitFunction = SRVSTATUS
'
ExitWkseqmInitFunction:
If rc Then
  WkseqmInitFunction = rc
ElseIf ID < 0 Then
  WkseqmInitFunction = -ID
End If
End Function

Sub scaleArray(ByVal scaleFactor As Single, myArray() As Single)
  Dim i As Integer
  For i = LBound(myArray) To UBound(myArray)
    myArray(i) = myArray(i) * scaleFactor
  Next
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' include WkseqmEqpFcn in the EqpFcn event of the Srv control
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub WkseqmEqpFcn(srvControl As Srv, ByVal devName As String, ByVal devProperty As String, ByVal outArrayLen As Long, ByVal inArrayLen As Long, ByVal devAccess As Integer)
Dim i As Integer
Dim devNr As Integer
Dim lclAmplitude As Single
' If your properties make use of the device number associated with the device name:
devNr = srvControl.EqpGetModuleNumberEx(devName, devProperty)
If devNr < 0 Then
    srvControl.EqpSetCompletion illegal_equipment_number, ""
    Exit Sub
End If
' check which property was asked for:
Select Case devProperty
  Case "Temperature"
    If (devAccess And CA_WRITE) Then
      srvControl.EqpSetCompletion illegal_read_write, ""
      Exit Sub
    End If
    If (outArrayLen > 0) And (outArrayLen <= (PRP_TEMPERATURE_SIZE - devNr)) Then
      srvControl.EqpSendData prpTemperatureBuffer(devNr)
    Else
      srvControl.EqpSetCompletion dimension_error, ""
      Exit Sub
    End If
  Case "Amplitude"
    If (devAccess And CA_WRITE) Then
      If inArrayLen = 0 Then
        srvControl.EqpSetCompletion illegal_read_write, ""
        Exit Sub
      End If
      ' Get the incoming data:
      srvControl.EqpRecvData lclAmplitude
      ' Do range checking:
      If lclAmplitude > PRP_AMPLITUDE_UPRLIMIT Then
        srvControl.EqpSetCompletion out_of_range, ""
        Exit Sub
      End If
      If lclAmplitude < PRP_AMPLITUDE_LWRLIMIT Then
        srvControl.EqpSetCompletion out_of_range, ""
        Exit Sub
      End If
      ' Copy incoming data into global data buffer
      'prpAmplitude = lclAmplitude
      prpAmplitudeBuffer(devNr) = lclAmplitude
      
      ' send this to the corresponding hardware device ...
      setValue "Amplitude" + Trim$(str(devNr)), CInt(lclAmplitude)
    End If
    If (outArrayLen > 0) And (outArrayLen <= (PRP_AMPLITUDE_SIZE - devNr)) Then
'      Dim v(0) As Integer, fv As Single
'      'getValues "#" + Trim$(str(devNr)), v
'      'v(0) = prpAmplitudeBuffer(devNr)
'      v(0) = gCdiOutput(devNr)
'      fv = v(0)
      srvControl.EqpSendData prpAmplitudeBuffer(devNr)
    Else
      srvControl.EqpSetCompletion dimension_error, ""
      Exit Sub
    End If
  Case "Sine"
    If (devAccess And CA_WRITE) Then
      srvControl.EqpSetCompletion illegal_read_write, ""
      Exit Sub
    End If
    If outArrayLen > 0 Then
      MEMCPY rbSineBuffer(0), prpSineBuffer(0), PRP_SINE_SIZE * 4
      scaleArray prpAmplitudeBuffer(devNr), rbSineBuffer()
      srvControl.EqpSendData rbSineBuffer
    End If

  Case Else
    srvControl.EqpSetCompletion illegal_property, ""
    Exit Sub
End Select
' If it's made it this far, it's a success:
srvControl.EqpSetCompletion 0, ""
End Sub
