/*
 * Created on May 18, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.simple.cdi;

import de.desy.cdi.Cdi;
import de.desy.tine.client.*;
import de.desy.tine.dataUtils.*;
import de.desy.tine.definitions.*;

public class HdwIo 
{
  static public final String cdiPrefix = "/localhost/cdi/";
  static private short[] inputword = new short[1];
  static private short[] outputword = new short[3];
  static private short[] outputbuffer = null;
  static private TLink tempLink = null;   // reference to temp monitor link
  static private TLink amplLink = null;   // reference to ampl monitor link
  static private TLink sineLink = null;   // reference to sine monitor link
  static private TLink hwdSetLink = null; // reference to single set link
  static private TLink hwdGetLink = null; // reference to single get link
  static private TDataType din = null;
  static private TDataType dout = null;
  static private short[] tempRb = new short[100];
  static private short[] amplRb = new short[100];
  static private short[] sineRb = new short[1024];
  static boolean isInitialized = false;
  public static short[] getOutput() { return outputword; }
  public static int setValue(String hwDeviceName,int inputValue)
  {
    if (din == null) din = new TDataType(inputword);
    inputword[0] = (short)inputValue;
    if (hwdSetLink == null || hwdSetLink.getDeviceName().compareTo(hwDeviceName) != 0)
    { // do we have to make a new TLink ?
      hwdSetLink = new TLink(cdiPrefix + hwDeviceName,"SEND",null,din,TAccess.CA_WRITE);
    }
    return hwdSetLink.execute(100);
  }
  public static int getValues(String hwDeviceName,short[] hwOutputBuffer)
  {
    return getValues(hwDeviceName,hwOutputBuffer,0);
  }
  public static int getValues(String hwDeviceName,short[] hwOutputBuffer,int outputlength)
  {
    boolean outputbufferChanged = false;
    if (hwDeviceName == null || hwOutputBuffer == null) return TErrorList.argument_list_error;
    if (outputlength <= 0) outputlength = hwOutputBuffer.length;
    if (outputlength > hwOutputBuffer.length) outputlength = hwOutputBuffer.length;
    if (dout == null || hwOutputBuffer != outputbuffer)
    { // is the output buffer the same as last time ?
      outputbuffer = hwOutputBuffer;
      dout = new TDataType(hwOutputBuffer,outputlength);
      outputbufferChanged = true;
    }
    if (hwdGetLink == null || 
        hwdGetLink.getDeviceName().compareTo(hwDeviceName) != 0 ||
        outputbufferChanged)
    { // do we have to make a new TLink ?
      hwdGetLink = new TLink(cdiPrefix + hwDeviceName,"RECV",dout,null,TAccess.CA_READ);
    }
    return hwdGetLink.execute(100);
  }
  public static void start()
  { // call this test method as an alternative to a background task
    // start up CDI ...
    Cdi.start();
    
    // write something to some registered devices ...
    // using device numbers in the server code is probably preferable
    // as the maybe only the database knows what names were assigned ...
    setValue("#1",66);

    // start a read monitor on the temperature devices ...
    tempLink = new TLink(cdiPrefix + "#1-#100","RECV",new TDataType(tempRb),null,TAccess.CA_READ);
    HdwIoCallback tempCb = new HdwIoCallback();
    tempLink.attach(TMode.CM_POLL,tempCb,1000);
    System.out.println("temp link status : " + tempLink.getLinkStatus());
    
    // start a read monitor on the temperature devices ...
    amplLink = new TLink(cdiPrefix + "#101-#200","RECV",new TDataType(amplRb),null,TAccess.CA_READ);
    HdwIoCallback amplCb = new HdwIoCallback();
    amplLink.attach(TMode.CM_POLL,amplCb,1000);
    System.out.println("ampl link status : " + amplLink.getLinkStatus());

    // start a read monitor on the temperature devices ...
    sineLink = new TLink(cdiPrefix + "#201","RECV",new TDataType(sineRb),null,TAccess.CA_READ);
    HdwIoCallback sineCb = new HdwIoCallback();
    sineLink.attach(TMode.CM_POLL,sineCb,1000);
    System.out.println("sine link status : " + sineLink.getLinkStatus());
  }
  public static short[] getAmplRb()
  {
    return amplRb;
  }
  public static short[] getSineRb()
  {
    return sineRb;
  }
  public static short[] getTempRb()
  {
    return tempRb;
  }
  public static TLink getAmplLink()
  {
    return amplLink;
  }
  public static TLink getSineLink()
  {
    return sineLink;
  }
  public static TLink getTempLink()
  {
    return tempLink;
  }
}
